/*							-- DO NOT EDIT --
 * Generated by smidump version 0.4.8:
 *   smidump -f scli IANA-MAU-MIB
 *
 * Derived from IANA-MAU-MIB:
 *   This MIB module defines dot3MauType OBJECT-IDENTITIES and
 *   IANAifMauListBits, IANAifMauMediaAvailable,
 *   IANAifMauAutoNegCapBits, and IANAifJackType
 *   
 *   TEXTUAL-CONVENTIONs, specifying enumerated values of the
 *   ifMauTypeListBits, ifMauMediaAvailable / rpMauMediaAvailable,
 *   ifMauAutoNegCapabilityBits / ifMauAutoNegCapAdvertisedBits /
 *   ifMauAutoNegCapReceivedBits and ifJackType / rpJackType objects
 *   respectively, defined in the MAU-MIB.
 *   
 *   It is intended that each new MAU type, Media Availability
 *   state, Auto Negotiation capability and/or Jack type defined by
 *   the IEEE 802.3 working group and approved for publication in a
 *   revision of IEEE Std 802.3 will be added to this MIB module,
 *   provided that it is suitable for being managed by the base
 *   objects in the MAU-MIB.  An Expert Review, as defined in
 *   RFC 2434 [RFC2434], is REQUIRED for such additions.
 *   
 *   The following reference is used throughout this MIB module:
 *   
 *   [IEEE802.3] refers to:
 *      IEEE Std 802.3, 2005 Edition: 'IEEE Standard for
 *      Information technology - Telecommunications and information
 *      exchange between systems - Local and metropolitan area
 *      networks - Specific requirements -
 *      Part 3: Carrier sense multiple access with collision
 *      detection (CSMA/CD) access method and physical layer
 *      specifications'.
 *   
 *   This reference should be updated as appropriate when new
 *   MAU types, Media Availability states, Auto Negotiation
 *   capabilities, and/or Jack types are added to this MIB module.
 *   
 *   Copyright (C) The IETF Trust (2007).
 *   The initial version of this MIB module was published in
 *   RFC 4836; for full legal notices see the RFC itself.
 *   Supplementary information may be available at:
 *   http://www.ietf.org/copyrights/ianamib.html
 *
 * Revision 2007-04-21 00:00:
 *   Initial version of this MIB as published in
 *   RFC 4836.
 *
 * $Id$
 */

#ifndef _IANA_MAU_MIB_H_
#define _IANA_MAU_MIB_H_

#include "gsnmp.h"

G_BEGIN_DECLS

/*
 * Tables to map enumerations to strings and vice versa.
 */

#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_OTHER            1
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_UNKNOWN          2
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_AVAILABLE        3
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_NOTAVAILABLE     4
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_REMOTEFAULT      5
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_INVALIDSIGNAL    6
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_REMOTEJABBER     7
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_REMOTELINKLOSS   8
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_REMOTETEST       9
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_OFFLINE          10
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_AUTONEGERROR     11
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_PMDLINKFAULT     12
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_WISFRAMELOSS     13
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_WISSIGNALLOSS    14
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_PCSLINKFAULT     15
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_EXCESSIVEBER     16
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_DXSLINKFAULT     17
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_PXSLINKFAULT     18
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_AVAILABLEREDUCED 19
#define IANA_MAU_MIB_IANAIFMAUMEDIAAVAILABLE_READY            20

extern GNetSnmpEnum const iana_mau_mib_enums_IANAifMauMediaAvailable[];

#define IANA_MAU_MIB_IANAIFJACKTYPE_OTHER    1
#define IANA_MAU_MIB_IANAIFJACKTYPE_RJ45     2
#define IANA_MAU_MIB_IANAIFJACKTYPE_RJ45S    3
#define IANA_MAU_MIB_IANAIFJACKTYPE_DB9      4
#define IANA_MAU_MIB_IANAIFJACKTYPE_BNC      5
#define IANA_MAU_MIB_IANAIFJACKTYPE_FAUI     6
#define IANA_MAU_MIB_IANAIFJACKTYPE_MAUI     7
#define IANA_MAU_MIB_IANAIFJACKTYPE_FIBERSC  8
#define IANA_MAU_MIB_IANAIFJACKTYPE_FIBERMIC 9
#define IANA_MAU_MIB_IANAIFJACKTYPE_FIBERST  10
#define IANA_MAU_MIB_IANAIFJACKTYPE_TELCO    11
#define IANA_MAU_MIB_IANAIFJACKTYPE_MTRJ     12
#define IANA_MAU_MIB_IANAIFJACKTYPE_HSSDC    13
#define IANA_MAU_MIB_IANAIFJACKTYPE_FIBERLC  14
#define IANA_MAU_MIB_IANAIFJACKTYPE_CX4      15

extern GNetSnmpEnum const iana_mau_mib_enums_IANAifJackType[];


/*
 * Tables to map identities to strings and vice versa.
 */

#define IANA_MAU_MIB_DOT3MAUTYPEAUI	1,3,6,1,2,1,26,4,1
#define IANA_MAU_MIB_DOT3MAUTYPE10BASE5	1,3,6,1,2,1,26,4,2
#define IANA_MAU_MIB_DOT3MAUTYPEFOIRL	1,3,6,1,2,1,26,4,3
#define IANA_MAU_MIB_DOT3MAUTYPE10BASE2	1,3,6,1,2,1,26,4,4
#define IANA_MAU_MIB_DOT3MAUTYPE10BASET	1,3,6,1,2,1,26,4,5
#define IANA_MAU_MIB_DOT3MAUTYPE10BASEFP	1,3,6,1,2,1,26,4,6
#define IANA_MAU_MIB_DOT3MAUTYPE10BASEFB	1,3,6,1,2,1,26,4,7
#define IANA_MAU_MIB_DOT3MAUTYPE10BASEFL	1,3,6,1,2,1,26,4,8
#define IANA_MAU_MIB_DOT3MAUTYPE10BROAD36	1,3,6,1,2,1,26,4,9
#define IANA_MAU_MIB_DOT3MAUTYPE10BASETHD	1,3,6,1,2,1,26,4,10
#define IANA_MAU_MIB_DOT3MAUTYPE10BASETFD	1,3,6,1,2,1,26,4,11
#define IANA_MAU_MIB_DOT3MAUTYPE10BASEFLHD	1,3,6,1,2,1,26,4,12
#define IANA_MAU_MIB_DOT3MAUTYPE10BASEFLFD	1,3,6,1,2,1,26,4,13
#define IANA_MAU_MIB_DOT3MAUTYPE100BASET4	1,3,6,1,2,1,26,4,14
#define IANA_MAU_MIB_DOT3MAUTYPE100BASETXHD	1,3,6,1,2,1,26,4,15
#define IANA_MAU_MIB_DOT3MAUTYPE100BASETXFD	1,3,6,1,2,1,26,4,16
#define IANA_MAU_MIB_DOT3MAUTYPE100BASEFXHD	1,3,6,1,2,1,26,4,17
#define IANA_MAU_MIB_DOT3MAUTYPE100BASEFXFD	1,3,6,1,2,1,26,4,18
#define IANA_MAU_MIB_DOT3MAUTYPE100BASET2HD	1,3,6,1,2,1,26,4,19
#define IANA_MAU_MIB_DOT3MAUTYPE100BASET2FD	1,3,6,1,2,1,26,4,20
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEXHD	1,3,6,1,2,1,26,4,21
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEXFD	1,3,6,1,2,1,26,4,22
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASELXHD	1,3,6,1,2,1,26,4,23
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASELXFD	1,3,6,1,2,1,26,4,24
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASESXHD	1,3,6,1,2,1,26,4,25
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASESXFD	1,3,6,1,2,1,26,4,26
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASECXHD	1,3,6,1,2,1,26,4,27
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASECXFD	1,3,6,1,2,1,26,4,28
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASETHD	1,3,6,1,2,1,26,4,29
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASETFD	1,3,6,1,2,1,26,4,30
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASEX	1,3,6,1,2,1,26,4,31
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASELX4	1,3,6,1,2,1,26,4,32
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASER	1,3,6,1,2,1,26,4,33
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASEER	1,3,6,1,2,1,26,4,34
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASELR	1,3,6,1,2,1,26,4,35
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASESR	1,3,6,1,2,1,26,4,36
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASEW	1,3,6,1,2,1,26,4,37
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASEEW	1,3,6,1,2,1,26,4,38
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASELW	1,3,6,1,2,1,26,4,39
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASESW	1,3,6,1,2,1,26,4,40
#define IANA_MAU_MIB_DOT3MAUTYPE10GIGBASECX4	1,3,6,1,2,1,26,4,41
#define IANA_MAU_MIB_DOT3MAUTYPE2BASETL	1,3,6,1,2,1,26,4,42
#define IANA_MAU_MIB_DOT3MAUTYPE10PASSTS	1,3,6,1,2,1,26,4,43
#define IANA_MAU_MIB_DOT3MAUTYPE100BASEBX10D	1,3,6,1,2,1,26,4,44
#define IANA_MAU_MIB_DOT3MAUTYPE100BASEBX10U	1,3,6,1,2,1,26,4,45
#define IANA_MAU_MIB_DOT3MAUTYPE100BASELX10	1,3,6,1,2,1,26,4,46
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEBX10D	1,3,6,1,2,1,26,4,47
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEBX10U	1,3,6,1,2,1,26,4,48
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASELX10	1,3,6,1,2,1,26,4,49
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEPX10D	1,3,6,1,2,1,26,4,50
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEPX10U	1,3,6,1,2,1,26,4,51
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEPX20D	1,3,6,1,2,1,26,4,52
#define IANA_MAU_MIB_DOT3MAUTYPE1000BASEPX20U	1,3,6,1,2,1,26,4,53

extern GNetSnmpIdentity const iana_mau_mib_identities[];

G_END_DECLS

#endif /* _IANA_MAU_MIB_H_ */
